/*  yasep/gui-js/XHR.js
created ven. sept.  9 08:26:10 CEST 2011 by whygee@f-cpu.org
version ven. sept.  9 23:01:24 CEST 2011 : added language support
version dim. sept. 18 13:43:16 CEST 2011 : back to .html, removing header and footer

This file deals with loading and storing data to/from the disk.
It mainly used to import HTML from external files.
*/

// Synchronous/blocking load.
function import_data(url) {
  try{
    var loader= new XMLHttpRequest();
    loader.open('GET', url, false);
    loader.send(null);
    return loader.responseText;
  }
  catch(err) {
    return "ERROR!";
  }
}


// Synchronous/blocking load.
function import_htmi(namebase,l) {
  if (typeof l == "undefined") {
    l=LANG.LANG;
  }
  var xhr;
  var n=namebase+'.'+LANG.LANGS[l]+'.html';
  try{
    xhr=new XMLHttpRequest();
    xhr.open('GET', n, false);
    xhr.send(null);

    if (xhr.status && (xhr.status != 200))
      throw "http";
    // Opera doesn't seem to "catch" some errors in local files... :-(
    // So I add the detection of a necessary keyword.
    if (xhr.responseText.indexOf('"hiddenDiv"') > 1) {
      // keep only the parts between those tags:
      var startHTMI="<!--startHTMI-->";
      var endHTMI="<!--endHTMI-->";

      var s=xhr.responseText.indexOf(startHTMI);
      if (s<0)
        s=0;
      else
        s+=startHTMI.length;

      var e=xhr.responseText.indexOf(endHTMI);
      if (e<0)
        e=xhr.responseText.length;

      return xhr.responseText.slice(s,e);
    }
  }
  catch(err) {
  }
  // we get here because no return yet,
  // either "catch" worked or Opera failed.
  if (l==0) // already tried, abort
    return alert("ERROR! "+n+' not found');
  else // try with the default language
    return import_htmi(namebase,0);
}
